## marble 24.12.2

=== debian/changelog ===
marble (4:24.12.2-3) unstable; urgency=medium

  * Stop depending on dummy package for armhf; build with -Os on armhf
    (Closes: #1098902), thanks to Adrian Bunk

 -- Matthias Geiger <werdahias@debian.org>  Tue, 25 Feb 2025 23:31:00 +0100

marble (4:24.12.2-2) unstable; urgency=medium

  * 'acc' autopkgtest: set -std=c++17, needed for Qt 6

 -- Matthias Geiger <werdahias@debian.org>  Sat, 22 Feb 2025 16:14:31 +0100

marble (4:24.12.2-1) unstable; urgency=medium

  * New upstream release 24.12.2 
  * d/control: Update my mail address
  * d/control: Depend on uninstallable armhf package to prevent armhf
    build

 -- Matthias Geiger <werdahias@debian.org>  Wed, 19 Feb 2025 15:13:34 +0100

marble (4:22.12.3-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop libqt5webkit5-dev from (Build-)Depends. (Closes: #1094740)

 -- Bastian Germann <bage@debian.org>  Mon, 10 Feb 2025 21:44:51 +0100

marble (4:24.12.0-2) experimental; urgency=medium

  [ Aurélien COUDERC ]
  * Update symbols from buildds for 4:24.12.0.

 -- Aurélien COUDERC <coucouf@debian.org>  Tue, 21 Jan 2025 18:53:12 +0100

marble (4:24.12.0-1) experimental; urgency=medium

  [ Matthias Geiger ]
  * New upstream release. 
  * Updated libmarblewidget-qt5-28.install for new version.
  * Drop marble.knsrc from marble-data.install
  * Updated libmarblewidget-qt5-28.symbols for new symbols

  [ Aurélien COUDERC ]
  * New upstream release (24.12.0).
  * Switch library soname to libmarblewidget-qt6-28.
  * Update the list of installed files.
  * Split marble-behaim into its own binary package.
  * Add binary packages for qml6-module-org-kde-marble and
    qml6-module-org-kde-marble-imageprovider.
  * Update symbols from build for 24.12.0.
  * Bump Standards-Version to 4.7.0, no change required.
  * Review copyright information.
  * Switch away from transitional pkg-config build dependency.
  * Drop obsolete lintian overrides.
  * Switch to declarative KF6 and pkgkde_symbolshelper debhelper build
    sequences.
  * Switch to dh_qmldeps for runtime QML dependencies.
  * Drop obsolete Breaks/Replaces.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 30 Dec 2024 19:11:01 +0100

=== debian/control ===
Source: marble
Section: kde
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Matthias Geiger <werdahias@debian.org>,
Build-Depends: debhelper-compat (= 13),
	           dh-sequence-kf6,
               dh-sequence-pkgkde-symbolshelper,
               dh-sequence-qmldeps,
               cmake (>= 3.20~),
               extra-cmake-modules (>= 6.5.0~),
               gettext,
               libabsl-dev,
               libgps-dev (>= 3.22),
               libkf6config-dev (>= 6.5.0~),
               libkf6coreaddons-dev (>= 6.5.0~),
               libkf6crash-dev (>= 6.5.0~),
               libkf6doctools-dev (>= 6.4.0~),
               libkf6i18n-dev (>= 6.5.0~),
               libkf6kio-dev (>= 6.4.0~),
               libkf6parts-dev (>= 6.5.0~),
               libkf6runner-dev (>= 6.5.0~),
               libopencv-core-dev,
               libopencv-highgui-dev,
               libopencv-imgproc-dev,
               libopencv-videoio-dev,
               libphonon4qt6-dev,
               libphonon4qt6experimental-dev,
               libplasma-dev (>= 6.0.0~),
               libprotobuf-dev,
               libprotoc-dev,
               libshp-dev,
               pkg-kde-tools,
               pkgconf,
               protobuf-compiler,
               qml6-module-org-kde-kcmutils,
               qml6-module-org-kde-kirigamiaddons-formcard,
               qml6-module-org-kde-plasma-plasma5support,
               qt6-5compat-dev (>= 6.6~),
               qt6-base-dev (>= 6.6~),
               qt6-declarative-dev (>= 6.6~),
               qt6-declarative-private-dev,
               qt6-multimedia-dev,
               qt6-positioning-dev,
               qt6-serialport-dev,
               qt6-svg-dev (>= 6.6~),
               qt6-tools-dev,
               qt6-webengine-dev (>= 6.6~) [amd64 arm64 armhf i386],
               shared-mime-info,
               zlib1g-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://marble.kde.org/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/marble
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/marble.git

Package: libastro-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libastro1 (= ${binary:Version}), ${misc:Depends},
Description: development files for the Marble astrononmy library
 Marble is a generic geographical map widget and framework for KDE
 applications. The Marble widget shows the earth as a sphere but does not
 require hardware acceleration.  A minimal set of geographical data is
 included, so it can be used without an internet connection.
 .
 This package contains development files for building software that uses the
 Marble astronomy library
 .
 This package is part of the KDE education module.

Package: libastro1
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Marble astronomy library
 Marble is a generic geographical map widget and framework for KDE
 applications. The Marble widget shows the earth as a sphere but does not
 require hardware acceleration.  A minimal set of geographical data is
 included, so it can be used without an internet connection.
 .
 This package contains shared libraries for astronomy support in marble.
 .
 This package is part of the KDE education module.

Package: libmarble-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libastro-dev (= ${binary:Version}),
         libmarblewidget-qt6-28 (= ${binary:Version}),
         qt6-svg-dev (>= 6.6~),
         qt6-declarative-dev (>= 6.6~),
         qt6-webengine-dev (>= 6.6~) [amd64 arm64 armhf i386],
         ${misc:Depends},
         ${sameVersionDep:qt6-base-dev:libmarblewidget-qt6-28},
         ${shlibs:Depends},
Description: development files for the Marble globe widget library
 Marble is a generic geographical map widget and framework for KDE
 applications. The Marble widget shows the earth as a sphere but does not
 require hardware acceleration.  A minimal set of geographical data is
 included, so it can be used without an internet connection.
 .
 This package contains development files for building software that uses the
 Marble globe widget library.
 .
 This package is part of the KDE education module.

Package: libmarblewidget-qt6-28
Architecture: any
Section: libs
Multi-Arch: same
Depends: marble-qt-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: marble-plugins (= ${binary:Version}),
Description: Marble globe widget library
 Marble is a generic geographical map widget and framework for KDE
 applications. The Marble widget shows the earth as a sphere but does not
 require hardware acceleration.  A minimal set of geographical data is
 included, so it can be used without an internet connection.
 .
 This package contains shared libraries for the Marble globe widget.
 .
 This package is part of the KDE education module.

Package: marble
Architecture: any
Section: misc
Depends: marble-data (>= ${source:Version}),
         marble-plugins (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Suggests: gosmore, monav-routing-daemon, routino,
Description: globe and map widget
 Marble is a generic geographical map widget and framework for KDE
 applications. The Marble widget shows the earth as a sphere but does not
 require hardware acceleration.  A minimal set of geographical data is
 included, so it can be used without an internet connection.
 .
 This package is part of the KDE education module.

Package: marble-behaim
Architecture: any
Section: misc
Depends: marble-data (>= ${source:Version}),
         marble-plugins (= ${binary:Version}),
         ${misc:Depends},
         ${qml6:Depends},
         ${shlibs:Depends},
Breaks: marble-maps (<< 4:24.12.0-1~),
Replaces: marble-maps (<< 4:24.12.0-1~),
Description: Behaim globe
 Marble is a generic geographical map widget and framework for KDE
 applications. The Marble widget shows the earth as a sphere but does not
 require hardware acceleration.  A minimal set of geographical data is
 included, so it can be used without an internet connection.
 .
 This package displays a virtual representation of Martin Behaim’s globe.
 .
 This package is part of the KDE education module.

Package: marble-data
Architecture: all
Section: misc
Multi-Arch: foreign
Depends: marble-qt-data (= ${source:Version}), ${misc:Depends},
Description: data files for Marble
 Marble is a generic geographical map widget and framework for KDE
 applications. The Marble widget shows the earth as a sphere but does not
 require hardware acceleration.  A minimal set of geographical data is
 included, so it can be used without an internet connection.
 .
 This package contains the architecture-independent data files for the Marble
 desktop globe.
 .
 This package is part of the KDE education module.

Package: marble-maps
Architecture: any
Section: misc
Depends: marble-data (>= ${source:Version}),
         marble-plugins (= ${binary:Version}),
         ${misc:Depends},
         ${qml6:Depends},
         ${shlibs:Depends},
Suggests: gosmore, monav-routing-daemon, routino,
Description: globe and map widget for mobile form factors
 Marble is a generic geographical map widget and framework for KDE
 applications. The Marble widget shows the earth as a sphere but does not
 require hardware acceleration.  A minimal set of geographical data is
 included, so it can be used without an internet connection.
 .
 This package is part of the KDE education module.

Package: marble-plugins
Architecture: any
Section: misc
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: plugins for Marble
 Marble is a generic geographical map widget and framework for KDE
 applications. The Marble widget shows the earth as a sphere but does not
 require hardware acceleration.  A minimal set of geographical data is
 included, so it can be used without an internet connection.
 .
 This package contains various plugins for the Marble desktop globe. The Marble
 globe widget library may not be of much use if this package is not installed.
 .
 This package is part of the KDE education module.

Package: marble-qt
Architecture: any
Section: misc
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: globe and map widget (no KDE dependencies)
 Marble is a generic geographical map widget and framework for KDE
 applications. The Marble widget shows the earth as a sphere but does not
 require hardware acceleration.  A minimal set of geographical data is
 included, so it can be used without an internet connection.
 .
 This package provides a build of Marble that only depends on Qt libraries
 with no additional KDE dependencies.
 .
 This package is part of the KDE education module.

Package: marble-qt-data
Architecture: all
Section: misc
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: Qt-only data files for Marble
 Marble is a generic geographical map widget and framework for KDE
 applications. The Marble widget shows the earth as a sphere but does not
 require hardware acceleration.  A minimal set of geographical data is
 included, so it can be used without an internet connection.
 .
 This package contains the architecture-independent data files for the Qt-only
 version of the Marble desktop globe.
 .
 This package is part of the KDE education module.

Package: plasma-marble
Architecture: any
Section: misc
Depends: marble-data (>= ${source:Version}),
         marble-plugins (= ${binary:Version}),
         plasma-framework,
         ${misc:Depends},
         ${qml6:Depends},
         ${shlibs:Depends},
Description: Plasma integration for Marble
 Marble is a generic geographical map widget and framework for KDE
 applications. The Marble widget shows the earth as a sphere but does not
 require hardware acceleration.  A minimal set of geographical data is
 included, so it can be used without an internet connection.
 .
 This package contains the Marble integration with Plasma:
  * the Plasma runner
  * the World Clock widget
  * the Plasma wallpaper
 .
 This package is part of the KDE education module.

Package: qml6-module-org-kde-marble
Architecture: any
Section: misc
Depends: ${misc:Depends},
         ${qml6:Depends},
         ${shlibs:Depends},
Description: Marble QML module
 Marble is a generic geographical map widget and framework for KDE
 applications. The Marble widget shows the earth as a sphere but does not
 require hardware acceleration.  A minimal set of geographical data is
 included, so it can be used without an internet connection.
 .
 This package contains the QML bindings for libmarble.
 .
 This package is part of the KDE education module.

Package: qml6-module-org-kde-marble-imageprovider
Architecture: any
Section: misc
Depends: ${misc:Depends},
         ${qml6:Depends},
         ${shlibs:Depends},
Description: Marble impage provider QML module
 Marble is a generic geographical map widget and framework for KDE
 applications. The Marble widget shows the earth as a sphere but does not
 require hardware acceleration.  A minimal set of geographical data is
 included, so it can be used without an internet connection.
 .
 This package contains the QML bindings for libmarble’s image providers.
 .
 This package is part of the KDE education module.

## marble 24.12.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)

# KDE Application Version, managed by release script
set(RELEASE_SERVICE_VERSION_MAJOR "24")
set(RELEASE_SERVICE_VERSION_MINOR "12")
set(RELEASE_SERVICE_VERSION_MICRO "3")
set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

set(MARBLE_LIB_SOVERSION 28)

project(marble VERSION ${RELEASE_SERVICE_VERSION})

set(KF_MIN_VERSION "6.5.0")
set(QT_MIN_VERSION "6.6")

find_package(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH
    ${ECM_MODULE_PATH}
    ${CMAKE_SOURCE_DIR}/cmake/modules
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/src
    ${CMAKE_CURRENT_SOURCE_DIR}/cmake_find_rules
    ${CMAKE_CURRENT_SOURCE_DIR}/cmake_scripts
    ${CMAKE_MODULE_PATH}
)

include(FeatureSummary)
include(GNUInstallDirs)
include(GenerateExportHeader)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDEClangFormat)
include(KDEGitCommitHooks)

include(ECMSetupVersion)
include(ECMAddTests)
include(ECMInstallIcons)
include(ECMEnableSanitizers)
include(ECMCoverageOption)
include(ECMQtDeclareLoggingCategory)
include(ECMQmlModule)
include(ECMDeprecationSettings)
include(MarbleMacros)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

ecm_setup_version(${RELEASE_SERVICE_VERSION}
    VARIABLE_PREFIX MARBLE
    VERSION_HEADER ${CMAKE_CURRENT_BINARY_DIR}/src/lib/marble/marble_version.h
    SOVERSION 28
)

remove_definitions(-DQT_NO_CAST_FROM_ASCII -DQT_NO_KEYWORDS)

####################################################
# Generate the tiles with the tilecreator at compile time
# if this option is set, srtm.jpg will not be installed but the generated tiles instead
option(MOBILE "Create a Marble version optimized for handheld devices" OFF)

####################################################
# Provide opt-in switch for mobile variant, which is not only useful for Android.
option(BUILD_TOUCH "Build touch-friendly Marble version (on Android this option is bypassed)" OFF)

option(BUILD_QT_AND_KDE "Build pure Qt version and KDE version. Only useful for distributions who split the marble in two packages. Otherwise just provide the KDE version to your users.")

####################################################
# Build a D-Bus interface for the Marble widget
# This is disabled by default for all win32, apple and Android
if(WIN32 OR APPLE OR ANDROID)
    option(BUILD_WITH_DBUS "Build the D-Bus interface for the Marble widget" OFF)
else()
    option(BUILD_WITH_DBUS "Build the D-Bus interface for the Marble widget" ON)
endif()

option(BUILD_MARBLE_APPS "Build the main Marble applications" ON)
add_feature_info(MarbleApps BUILD_MARBLE_APPS "Build the main Marble applications")
add_definitions(-DQT_NO_CONTEXTLESS_CONNECT)
ecm_set_disabled_deprecation_versions(QT 5.15
    KF 6.7.0
)

find_package(Qt6 ${QT_MIN_VERSION} REQUIRED
    COMPONENTS
        Core
        Xml
        Network
        Widgets
        Svg
        SvgWidgets
        Sql
        Concurrent
        Quick
        PrintSupport
        Core5Compat
)

if(BUILD_TESTING)
    find_package(Qt6 ${QT_MIN_VERSION} REQUIRED COMPONENTS Test)
endif()

find_package(KF6 ${KF_MIN_VERSION} COMPONENTS CoreAddons I18n Config)
if(NOT ANDROID)
    find_package(KF6 ${KF_MIN_VERSION} COMPONENTS Crash Parts)
endif()

set_package_properties(KF6 PROPERTIES
    PURPOSE "Required for building the applications"
    TYPE RECOMMENDED
)

find_package(Protobuf)
set_package_properties(Protobuf PROPERTIES TYPE OPTIONAL PURPOSE "Parsing of OSM PBF files.")

if(ANDROID)
    find_package(Qt6Positioning ${REQUIRED_QT_VERSION} REQUIRED)
    find_package(Qt6Multimedia ${REQUIRED_QT_VERSION} REQUIRED)

   set(MARBLE_NO_WEBKITWIDGETS TRUE)
else()
    find_package(Qt6WebChannel ${REQUIRED_QT_VERSION})
    find_package(Qt6WebEngineWidgets ${REQUIRED_QT_VERSION})
    find_package(Qt6WebEngineQuick ${REQUIRED_QT_VERSION})

   if( NOT Qt6WebEngineWidgets_FOUND)
     set(MARBLE_NO_WEBKITWIDGETS TRUE)
   endif()
endif()

if(BUILD_WITH_DBUS)
  find_package(Qt6DBus ${REQUIRED_QT_VERSION})
  if(NOT Qt6DBus_FOUND)
    set(MARBLE_NO_DBUS TRUE)
  endif()
else()
  set(MARBLE_NO_DBUS TRUE)
endif()

SET(CMAKE_AUTOMOC TRUE)

# Use M_PI under Windows
if(WIN32)
    add_definitions(-D_USE_MATH_DEFINES)
endif( WIN32)

####################################################
# build unit tests

INCLUDE (CTest)
ENABLE_TESTING()

####################################################
set(PEDANTIC FALSE CACHE BOOL "Determines if we should compile with -Wall -Werror.")
set(WITH_DESIGNER_PLUGIN TRUE CACHE BOOL "Build plugins for Qt Designer")
add_feature_info("Qt Designer plugins" WITH_DESIGNER_PLUGIN "Marble widget support in Qt Designer. Toggle with WITH_DESIGNER_PLUGIN=YES/NO")

set(EXEC_INSTALL_PREFIX  ${CMAKE_INSTALL_PREFIX} CACHE PATH  "Base directory for executables and libraries" FORCE)
if(NOT QT_PLUGINS_DIR)
   set(QT_PLUGINS_DIR ${CMAKE_INSTALL_LIBDIR}/plugins)
endif()

####################################################
# Detect default for the user configurable MARBLE_DATA_PATH option

if(WIN32)
    set(data_dir data)
    set(locale_dir "${data_dir}/locale")
    set(plugin_dir plugins)
elseif(APPLE)
    # needed for finding bundle path in e.g. katlasdir.h
    FIND_LIBRARY(APP_SERVICES_LIBRARY ApplicationServices)
    MARK_AS_ADVANCED (APP_SERVICES_LIBRARY)
    SET(MAC_EXTRA_LIBS ${APP_SERVICES_LIBRARY})
      # for Mac OS X, everything is put inside an application bundle
      SET (CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}/)
      # path for library references
      SET (CMAKE_INSTALL_NAME_DIR @executable_path/lib)
      # install the Info.plist file
      install(FILES src/mac/Info.plist DESTINATION ${CMAKE_INSTALL_PREFIX}/Marble.app/Contents)
      #SET (lib_dir ${CMAKE_INSTALL_PREFIX}/Marble.app/Contents/MacOS/lib)
      SET (data_dir   ${CMAKE_INSTALL_PREFIX}/Marble.app/Contents/MacOS/resources/data)
      set(locale_dir "${data_dir}/locale")
      SET (plugin_dir   ${CMAKE_INSTALL_PREFIX}/Marble.app/Contents/MacOS/resources/plugins)
elseif(ANDROID)
      set(plugin_dir "${CMAKE_INSTALL_PREFIX}/assets/plugins")
      set(data_dir "${CMAKE_INSTALL_PREFIX}/assets/data")
      set(locale_dir "${data_dir}/locale")
else() # Linux / bsd etc...
      set(data_dir ${CMAKE_INSTALL_FULL_DATAROOTDIR}/marble/data)
      set(locale_dir "${CMAKE_INSTALL_FULL_DATAROOTDIR}/locale")
      set(plugin_dir ${CMAKE_INSTALL_FULL_LIBDIR}/marble/plugins)
endif()

if(NOT ICON_INSTALL_DIR)
	set(ICON_INSTALL_DIR share/icons)
endif(NOT ICON_INSTALL_DIR)

if(NOT APPS_INSTALL_DIR)
	set(APPS_INSTALL_DIR share/applications)
endif(NOT APPS_INSTALL_DIR)

if(NOT INCLUDE_INSTALL_DIR)
    set(INCLUDE_INSTALL_DIR "include")
endif()

if(NOT MARBLE_DATA_PATH)
  set(MARBLE_DATA_PATH ${data_dir})
endif(NOT MARBLE_DATA_PATH)

if(NOT MARBLE_PLUGIN_PATH)
  set(MARBLE_PLUGIN_PATH ${plugin_dir})
endif(NOT MARBLE_PLUGIN_PATH)

if(NOT MARBLE_DATA_INSTALL_PATH)
  set(MARBLE_DATA_INSTALL_PATH ${MARBLE_DATA_PATH})
endif(NOT MARBLE_DATA_INSTALL_PATH)

if(NOT MARBLE_PLUGIN_INSTALL_PATH)
  set(MARBLE_PLUGIN_INSTALL_PATH ${MARBLE_PLUGIN_PATH})
endif(NOT MARBLE_PLUGIN_INSTALL_PATH)

#message( STATUS, "MARBLE_PLUGIN_INSTALL_PATH: ${MARBLE_PLUGIN_INSTALL_PATH}")

if(WIN32)
  set(STATIC_BUILD FALSE CACHE BOOL "Link to static Qt libs (win32 only)?")
endif(WIN32)

add_definitions(
    -DQT_USE_QSTRINGBUILDER
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
)

if(NOT WIN32)
    # Strict iterators can't be used on Windows, they lead to a link error
    # when application code iterates over a QList<QPoint> for instance
    # See example at https://bugreports.qt.io/browse/QTBUG-78112
    add_definitions(-DQT_STRICT_ITERATORS)
endif()
####################################################
# Options for static build
if(STATIC_BUILD)
  set(BUILD_SHARED_LIBS FALSE)
  add_definitions(-DSTATIC_BUILD=1)
else()
  set(BUILD_SHARED_LIBS TRUE)
endif(STATIC_BUILD)

#############################################################
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_C_COMPILER MATCHES "icc")
    # Its good programming practice to build with no warnings...
    add_definitions( -Wall -Wextra -Wundef -Wnon-virtual-dtor -Woverloaded-virtual -Wno-long-long
                     -Wchar-subscripts -Wcast-align -Wpointer-arith -Wformat-security)

    # In pedantic mode, treat warnings as errors
    if(PEDANTIC)
        add_definitions( -Werror)
    endif(PEDANTIC)
endif(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_C_COMPILER MATCHES "icc")

#############################################################
# Add a compiler def so that we can conditionally compile
# code in debug mode only (e.g. extra console messages)
IF (CMAKE_BUILD_TYPE MATCHES Debug)
    IF(NOT MINGW)
        ADD_DEFINITIONS(-DDEBUG)
    ELSE(NOT MINGW)
        REMOVE_DEFINITIONS( -DQT_NO_DEBUG)
    ENDIF(NOT MINGW)
ENDIF (CMAKE_BUILD_TYPE MATCHES Debug)

####################################################
# on Win32 set the debug postfix
if(WIN32)
  # distinguish between debug and release plugin
  SET(CMAKE_DEBUG_POSTFIX "d")
endif(WIN32)
####################################################


####################################################
# Add global ECM & KF6 settings
set(KDE_INSTALL_DIRS_NO_DEPRECATED TRUE)
set(KDE_SKIP_UNINSTALL_TARGET ON CACHE BOOL "KDE uninstall target must be disabled")
set(REQUIRED_KF6_MIN_VERSION 6.4.0)

####################################################
# Add the include directories

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/src/lib/marble
  ${CMAKE_CURRENT_SOURCE_DIR}/src/lib/marble/projections
  ${CMAKE_CURRENT_SOURCE_DIR}/src/lib/marble/geodata
  ${CMAKE_CURRENT_SOURCE_DIR}/src/lib/marble/geodata/data
  ${CMAKE_CURRENT_SOURCE_DIR}/src/lib/marble/geodata/graphicsitem
  ${CMAKE_CURRENT_SOURCE_DIR}/src/lib/marble/geodata/handlers/dgml
  ${CMAKE_CURRENT_SOURCE_DIR}/src/lib/marble/geodata/parser
  ${CMAKE_CURRENT_SOURCE_DIR}/src/lib/marble/geodata/writer
  ${CMAKE_CURRENT_SOURCE_DIR}/src/lib/marble/geodata/scene
  ${CMAKE_CURRENT_SOURCE_DIR}/src/lib/marble/graphicsview
  ${CMAKE_CURRENT_BINARY_DIR}/src
  ${CMAKE_CURRENT_BINARY_DIR}/src/lib/marble
)
####################################################
# Descend into subdirectories
add_subdirectory(doc)
add_subdirectory(src)
add_subdirectory(data)

include(DistTarget)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

option(BUILD_MARBLE_TOOLS "Build various tools related to Marble" OFF)
add_feature_info("Marble tools" BUILD_MARBLE_TOOLS "Build various Marble tools for e.g. file format conversion. Toggle with BUILD_MARBLE_TOOLS=YES/NO.")
if(BUILD_MARBLE_TOOLS)
  add_subdirectory(tools)
endif()

option(BUILD_MARBLE_EXAMPLES "Build C++ examples showing how to use the Marble library" OFF)
add_feature_info("Marble library C++ examples" BUILD_MARBLE_EXAMPLES "Build C++ examples showing how to use the Marble library. Toggle with BUILD_MARBLE_EXAMPLES=YES/NO.")
if(BUILD_MARBLE_EXAMPLES)
  add_subdirectory(examples/cpp)
endif()

####################################################
# Handle translation catalogs of KDE Application release tarball of marble
# (for custom bundle translation handling see data/lang/README)

# KDE Application release tarballs have the respective po files added on tarball creation,
# which are otherwise stored and edited separately on the KDE svn servers.
# Toplevel subdir "poqm/" holds all the po files which should be processed and installed as qm files
marble_install_po_files_as_qm(poqm)

# Toplevel subdir "po/" holds all the po files which should be processed and installed as mo files
# Those are used by app and plugin code building against KI18n.
# So the respective macro ki18n_install can be used.
# Likewise, it contains the translated user documentation, which is handled by kdoctools_install.

=== examples/cpp/CMakeLists.txt ===
# Generate fake headers
# forwarding headers to simulate installed header paths with just a marble/ prefix
# for headers which are located in other prefixes in the sources
set(FAKEHEADERS_DIR ${CMAKE_CURRENT_BINARY_DIR}/fakeheaders)

function(generateFakeHeaders basedir)
    foreach(_filename ${ARGN})
        set(_fileContent "#include <${basedir}/${_filename}>")
        file(WRITE ${FAKEHEADERS_DIR}/marble/${_filename} ${_fileContent})
    endforeach()
endfunction()

# create clean dir
file(REMOVE_RECURSE ${FAKEHEADERS_DIR})
file(MAKE_DIRECTORY ${FAKEHEADERS_DIR}/marble)

generateFakeHeaders(geodata/data
    GeoDataCoordinates.h
    GeoDataDocument.h
    GeoDataFlyTo.h
    GeoDataGeometry.h
    GeoDataGroundOverlay.h
    GeoDataIconStyle.h
    GeoDataLatLonAltBox.h
    GeoDataLinearRing.h
    GeoDataLineString.h
    GeoDataLineStyle.h
    GeoDataLookAt.h
    GeoDataMultiGeometry.h
    GeoDataPlacemark.h
    GeoDataPlaylist.h
    GeoDataPoint.h
    GeoDataPolygon.h
    GeoDataPolyStyle.h
    GeoDataStyle.h
    GeoDataStyleMap.h
    GeoDataTour.h
)
generateFakeHeaders(geodata/parser
    GeoDataTypes.h
)
generateFakeHeaders(routing
    Route.h
    RouteRequest.h
    RoutingManager.h
    RoutingModel.h
)

# TODO: Change include directories for the library not to include all subdirectories,
# and change #include statements to use <marble/...> and "..." includes only
include_directories(
    ${CMAKE_SOURCE_DIR}/src/lib
    ${FAKEHEADERS_DIR}
)

set(MARBLE_EXAMPLES_INSTALL_DIR ${CMAKE_INSTALL_FULL_DATAROOTDIR}/apps/marble/examples)

add_subdirectory(hello-marble)
add_subdirectory(map-properties)
add_subdirectory(drawing-places)
add_subdirectory(kml-inspector)
add_subdirectory(map-controls)
add_subdirectory(overlay-rendering)
add_subdirectory(squad-interpolation)
add_subdirectory(geopainter)
add_subdirectory(basic-routing)
add_subdirectory(reverse-geocoding)
add_subdirectory(vehicletracking)
add_subdirectory(search)

add_subdirectory(marble-game)
add_subdirectory(marbleQuick2)

FIND_PACKAGE (OpenCV QUIET COMPONENTS core imgproc highgui videoio)
if(OPENCV_HIGHGUI_FOUND)
  add_subdirectory(animation-video)
  add_subdirectory(tour-preview)
endif()

=== src/plugins/CMakeLists.txt ===

# add_definitions(-DQT_NO_CAST_FROM_ASCII)
# Logging for Marble plugins
ecm_qt_export_logging_category(
    IDENTIFIER "MARBLE_PLUGINS"
    CATEGORY_NAME "marble_plugins"
    EXPORT marble
    DESCRIPTION "Marble (plugins)"
)
add_definitions("-DLOGGING_IDENTIFIER=MARBLE_PLUGINS")

if(NOT ANDROID)
    add_subdirectory(designer)
    add_subdirectory(templates)
endif()

add_subdirectory(render)
add_subdirectory(positionprovider)
add_subdirectory(runner)

=== tools/iau2kml/CMakeLists.txt ===
SET (TARGET iau2kml)
PROJECT (${TARGET})

include_directories(
 ${CMAKE_CURRENT_SOURCE_DIR}
 ${CMAKE_CURRENT_BINARY_DIR}
)

set(${TARGET}_SRC iau2kml.cpp)
add_executable(${TARGET} ${${TARGET}_SRC})

target_link_libraries(${TARGET} Qt6::Core)

=== examples/cpp/drawing-places/CMakeLists.txt ===
SET (TARGET drawing-places)
PROJECT (${TARGET})

include_directories(
 ${CMAKE_CURRENT_SOURCE_DIR}
 ${CMAKE_CURRENT_BINARY_DIR}
)

set(${TARGET}_SRC main.cpp)
add_executable(${TARGET} ${${TARGET}_SRC})

target_link_libraries(${TARGET} marblewidget)

install(TARGETS ${TARGET} RUNTIME DESTINATION ${MARBLE_EXAMPLES_INSTALL_DIR}/${TARGET})
install(FILES ${${TARGET}_SRC} Readme.txt DESTINATION ${MARBLE_EXAMPLES_INSTALL_DIR}/${TARGET})
install(FILES CMakeLists.txt.external DESTINATION ${MARBLE_EXAMPLES_INSTALL_DIR}/${TARGET} RENAME CMakeLists.txt)

=== examples/cpp/geopainter/CMakeLists.txt ===
SET (TARGET geopainter)
PROJECT (${TARGET})

include_directories(
 ${CMAKE_CURRENT_SOURCE_DIR}
 ${CMAKE_CURRENT_BINARY_DIR}
)

set(${TARGET}_SRC main.cpp)
add_executable(${TARGET} ${${TARGET}_SRC})

target_link_libraries(${TARGET} marblewidget)

install(TARGETS ${TARGET} RUNTIME DESTINATION ${MARBLE_EXAMPLES_INSTALL_DIR}/${TARGET})
install(FILES ${${TARGET}_SRC} Readme.txt DESTINATION ${MARBLE_EXAMPLES_INSTALL_DIR}/${TARGET})
install(FILES CMakeLists.txt.external DESTINATION ${MARBLE_EXAMPLES_INSTALL_DIR}/${TARGET} RENAME CMakeLists.txt)

=== examples/cpp/overlay-rendering/CMakeLists.txt ===
SET (TARGET overlay-rendering)
PROJECT (${TARGET})

include_directories(
 ${CMAKE_CURRENT_SOURCE_DIR}
 ${CMAKE_CURRENT_BINARY_DIR}
)

set(${TARGET}_SRC main.cpp)
add_executable(${TARGET} ${${TARGET}_SRC})

target_link_libraries(${TARGET} marblewidget)

install(TARGETS ${TARGET} RUNTIME DESTINATION ${MARBLE_EXAMPLES_INSTALL_DIR}/${TARGET})
install(FILES ${${TARGET}_SRC} Readme.txt DESTINATION ${MARBLE_EXAMPLES_INSTALL_DIR}/${TARGET})
install(FILES CMakeLists.txt.external DESTINATION ${MARBLE_EXAMPLES_INSTALL_DIR}/${TARGET} RENAME CMakeLists.txt)

=== examples/cpp/tour-preview/CMakeLists.txt ===
SET (TARGET tour-preview)
PROJECT (${TARGET})

include_directories(
 ${CMAKE_CURRENT_SOURCE_DIR}
 ${CMAKE_CURRENT_BINARY_DIR}
)

set(${TARGET}_SRC tour-preview.cpp)
add_executable(${TARGET} ${${TARGET}_SRC})

target_link_libraries(${TARGET} ${OpenCV_LIBS} marblewidget)

install(TARGETS ${TARGET} RUNTIME DESTINATION bin)

=== src/plugins/render/progress/CMakeLists.txt ===
PROJECT(ProgressFloatItem)

INCLUDE_DIRECTORIES(
 ${CMAKE_CURRENT_SOURCE_DIR}
 ${CMAKE_CURRENT_BINARY_DIR}
)

set(progress_SRCS ProgressFloatItem.cpp ProgressFloatItem.h)

marble_add_plugin( ProgressFloatItem ${progress_SRCS})

=== src/plugins/render/routing/CMakeLists.txt ===
PROJECT(RoutingPlugin)

macro_optional_find_package(Phonon4Qt6 QUIET)
marble_set_package_properties( Phonon4Qt6 PROPERTIES
    DESCRIPTION "Qt-based audio library"
    URL "https://phonon.kde.org/"
    PURPOSE "Voice navigation (sound or human speakers)"
    TYPE OPTIONAL
)

INCLUDE_DIRECTORIES(
 ${CMAKE_CURRENT_SOURCE_DIR}
 ${CMAKE_CURRENT_BINARY_DIR}
)

if(Phonon4Qt6_FOUND)
  set(routing_SRCS RoutingPlugin.cpp AudioOutput.cpp RoutingPlugin.h AudioOutput.h)
ELSE()
  set(routing_SRCS RoutingPlugin.cpp NullAudioOutput.cpp RoutingPlugin.h)
ENDIF()
set(routing_UI RoutingPlugin.ui RoutingConfigDialog.ui)
qt_wrap_ui( routing_SRCS ${routing_UI})
qt_add_resources(routing_SRCS routing.qrc)

marble_add_plugin( RoutingPlugin ${routing_SRCS})
if(Phonon4Qt6_FOUND)
    target_link_libraries(RoutingPlugin Phonon::phonon4qt6)
endif()

=== src/plugins/runner/latlon/CMakeLists.txt ===
PROJECT( LatLonPlugin)

INCLUDE_DIRECTORIES(
 ${CMAKE_CURRENT_SOURCE_DIR}
 ${CMAKE_CURRENT_BINARY_DIR}
)

set(latlon_SRCS LatLonRunner.cpp LatLonPlugin.cpp LatLonRunner.h LatLonPlugin.h)

marble_add_plugin( LatLonPlugin ${latlon_SRCS})

=== src/plugins/runner/log/CMakeLists.txt ===
PROJECT( LogPlugin)

INCLUDE_DIRECTORIES(
 ${CMAKE_CURRENT_SOURCE_DIR}
 ${CMAKE_CURRENT_BINARY_DIR}
)

set(log_SRCS LogPlugin.cpp LogRunner.cpp LogPlugin.h LogRunner.h)

marble_add_plugin( LogPlugin ${log_SRCS})

=== debian/changelog ===
marble (4:24.12.3-0ubuntu1) plucky; urgency=medium

  * New upstream release (24.12.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Mar 2025 08:50:30 +0000

marble (4:24.12.2-3ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Kubuntu Vcs and maintainer fileds.
    - Add apparmor profile to fix userns.
    - Disable acc test.

 -- Rik Mills <rikmills@kde.org>  Wed, 26 Feb 2025 07:33:47 +0000

marble (4:24.12.2-2ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Kubuntu Vcs and maintainer fileds.
    - Add apparmor profile to fix userns.
    - Disable acc test.

 -- Rik Mills <rikmills@kde.org>  Sun, 23 Feb 2025 09:20:20 +0000

marble (4:24.12.2-1ubuntu1) plucky; urgency=high

  * Merge from Debian unstable. Remaining changes:
    - Kubuntu Vcs and maintainer fileds.
    - Add apparmor profile to fix userns.
    - Disable acc test.

 -- Rik Mills <rikmills@kde.org>  Wed, 19 Feb 2025 19:56:25 +0000

marble (4:24.12.0-2ubuntu1) plucky; urgency=medium

  * Merge from Debian experimental. Remaining changes:
    - Kubuntu Vcs and maintainer fileds.
    - Add apparmor profile to fix userns.
    - Disable acc test.

 -- Rik Mills <rikmills@kde.org>  Mon, 10 Feb 2025 15:11:47 +0000

=== debian/rules ===
#!/usr/bin/make -f


export DEB_BUILD_MAINT_OPTIONS=hardening=+all
libpkgs_gen_strict_local_shlibs = $(libpkgs_all_packages)
include /usr/share/pkg-kde-tools/qt-kde-team/3/library-packages.mk

# workaround for https://gcc.gnu.org/bugzilla/show_bug.cgi?id=119015
ifneq (,$(filter $(DEB_HOST_ARCH), armhf))
  export DEB_CXXFLAGS_MAINT_APPEND += -Os
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -Skf6 -- -DWITH_DESIGNER_PLUGIN=ON \
				 -DMARBLE_INSTALL_ANDROID_APPS=ON \
				 -DBUILD_QT_AND_KDE=ON \
				 -DBUILD_TOUCH=ON \
				 -DBUILD_MARBLE_TESTS=FALSE \
				 $(conf_args)

execute_after_dh_auto_install:
	# remove extra license files
	rm -f debian/tmp/usr/share/marble/data/LICENSE.txt
	rm -rf debian/tmp/usr/share/marble/data/licenses/
	mkdir -p debian/tmp/etc/apparmor.d
	cp debian/marble-apparmor debian/tmp/etc/apparmor.d/usr.bin.marble
	dh_auto_install
	dh_apparmor --profile-name=usr.bin.marble -pmarble

override_dh_auto_test:
	# Disable the auto tests at build time
	:

override_dh_clean:
	dh_clean -Xdata/mwdbii/PISLAND.PNT.orig -Xdata/mwdbii/PLAKE.PNT.orig

override_dh_gencontrol-arch: libpkgs_gen_strict_local_shlibs
	dh_sameversiondep -a
	dh_gencontrol -a
